#include <fstream.h>
int main()
{
	ifstream in("input.in");
	ofstream out("output.out");
	int mas[50000];
	int n, i, j, temp, jtemp;
	in>>n;
	mas[1]=1;
	int size=1;
	for(i=2; i<=n;++i)
	{
		j=size;
		while(j!=1)
		{
			jtemp=j;
			if(j%2)
				jtemp--;
			jtemp/=2;
			temp = mas[jtemp];
			mas[jtemp]=mas[j];
			mas[j]=temp;
			j=jtemp;
		}
			
		size+=1;
		mas[size]=mas[1];
		mas[1]=i;
	}
	for(i=1;i<=n; ++i)
		out<<mas[i]<<" ";


	return 0;
}